-- name: [CS] Kid Goku
-- description: 
--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md
]]

local E_MODEL_KIDGOKU = smlua_model_util_get_id("kidgoku_geo")
local E_MODEL_KIDGOKUNOPOLE = smlua_model_util_get_id("kidgoku_nopole_geo")
local E_MODEL_KIDGOKUJP = smlua_model_util_get_id("kidgoku_geo")
local E_MODEL_KIDGOKUNOPOLEJP = smlua_model_util_get_id("kidgoku_nopole_geo")

local TEXT_MOD_NAME = "Kid Goku Pack"

local TEX_KIDGOKU = get_texture_info("kidgoku-icon") -- Located in "textures"
local TEX_KIDGOKU = get_texture_info("kidgoku-icon") -- Located in "textures"

    local PALETTE_GOKU = {
        [PANTS]  = "ff3700",
        [SHIRT]  = "ff3700",
        [GLOVES] = "0000ff",
        [SHOES] = "0000ff",
        [HAIR]   = "000000",
        [SKIN]   = "fec179",
        [CAP]    = "500000",
        [EMBLEM]   = "000000",
    }

local VOICETABLE_KIDGOKU = {
    [CHAR_SOUND_ATTACKED] = 'kidgoku_a.ogg',
    [CHAR_SOUND_DOH] = 'kidgoku_teh.ogg',
    [CHAR_SOUND_DROWNING] = 'kidgoku_aa.ogg',
    [CHAR_SOUND_DYING] = 'kidgoku_aa.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'kidgoku_hae.ogg',
    [CHAR_SOUND_HAHA] = 'kidgoku_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'kidgoku_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'kidgoku_allright.ogg',
    [CHAR_SOUND_HOOHOO] = 'kidgoku_ya.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'kidgoku_uh.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'kidgoku_allright.ogg',
    [CHAR_SOUND_ON_FIRE] = 'kidgoku_a.ogg',
    [CHAR_SOUND_OOOF] = 'kidgoku_aa.ogg',
    [CHAR_SOUND_OOOF2] = 'kidgoku_vomit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'kidgoku_tha.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'kidgoku_ha.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'kidgoku_hai.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'kidgoku_letsgo.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'kidgoku_haha.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'kidgoku_longa.ogg',
    [CHAR_SOUND_WAH2] = 'kidgoku_uh.ogg',
    [CHAR_SOUND_WHOA] = 'kidgoku_teh.ogg',
    [CHAR_SOUND_YAHOO] = 'kidgoku_tha.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'kidgoku_ya.ogg', 'kidgoku_ha.ogg', ' .ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'kidgoku_hoi.ogg', 'kidgoku_hai.ogg', 'kidgoku_tha.ogg'},
}

local VOICETABLE_JPGOKU = {
    [CHAR_SOUND_ATTACKED] = 'goku_jp_ku.mp3',
    [CHAR_SOUND_DOH] = 'goku_jp_ku.mp3',
    [CHAR_SOUND_DROWNING] = 'goku_jp_ku.mp3',
    [CHAR_SOUND_DYING] = 'goku_jp_yell.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'goku_jp_haa2.mp3',
    [CHAR_SOUND_HAHA] = 'goku_jp_haa3.mp3',
    [CHAR_SOUND_HAHA_2] = 'goku_jp_haaa.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'goku_jp_hihi.mp3',
    [CHAR_SOUND_HOOHOO] = 'goku_jp_haa2.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'goku_jp_ota.mp3',
    [CHAR_SOUND_OKEY_DOKEY] = 'goku_jp_hihi.mp3',
    [CHAR_SOUND_ON_FIRE] = 'goku_jp_burning.mp3',
    [CHAR_SOUND_OOOF] = 'goku_jp_ku.mp3',
    [CHAR_SOUND_OOOF2] = 'goku_jp_ota.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'goku_jp_ya3.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'goku_jp_ha2.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'goku_jp_ya.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'goku_jp_haaa.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'goku_jp_ya3.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'goku_jp_yell2.mp3',
    [CHAR_SOUND_WAH2] = 'goku_jp_woah.mp3',
    [CHAR_SOUND_WHOA] = 'goku_jp_yell2.mp3',
    [CHAR_SOUND_YAHOO] = 'goku_jp_ya3.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'goku_jp_ya1.mp3', 'goku_jp_ha2.mp3', 'goku_jp_hoi.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'goku_jp_ha2.mp3', 'goku_jp_hoi.mp3', 'goku_jp_tha.mp3'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Kid Goku (Power Pole)", {"You look pretty strong."}, "Berunas", {r = 255, g = 45, b = 0}, E_MODEL_KIDGOKU, CT_MARIO, TEX_KIDGOKU)
    _G.charSelect.character_add_palette_preset(E_MODEL_KIDGOKU, PALETTE_GOKU)
    _G.charSelect.character_add("Kid Goku", {"You look pretty strong."}, "Berunas", {r = 255, g = 45, b = 0}, E_MODEL_KIDGOKUNOPOLE, CT_MARIO, TEX_KIDGOKU)
    _G.charSelect.character_add_palette_preset(E_MODEL_KIDGOKUNOPOLE, PALETTE_GOKU)
    _G.charSelect.character_add("Kid Goku JP(Power Pole)", {"You look pretty strong."}, "Berunas", {r = 255, g = 45, b = 0}, E_MODEL_KIDGOKU, CT_MARIO, TEX_KIDGOKU)
    _G.charSelect.character_add_palette_preset(E_MODEL_KIDGOKUJP, PALETTE_GOKU)
    _G.charSelect.character_add("Kid Goku JP", {"You look pretty strong."}, "Berunas", {r = 255, g = 45, b = 0}, E_MODEL_KIDGOKUNOPOLE, CT_MARIO, TEX_KIDGOKU)
    _G.charSelect.character_add_palette_preset(E_MODEL_KIDGOKUNOPOLEJP, PALETTE_GOKU)

    _G.charSelect.character_add_voice(E_MODEL_KIDGOKU, VOICETABLE_KIDGOKU)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_KIDGOKU then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_KIDGOKU then return _G.charSelect.voice.snore(m) end
    end)
    _G.charSelect.character_add_voice(E_MODEL_KIDGOKUNOPOLE, VOICETABLE_KIDGOKU)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_KIDGOKU then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_KIDGOKU then return _G.charSelect.voice.snore(m) end
    end)
    _G.charSelect.character_add_voice(E_MODEL_KIDGOKUJP, VOICETABLE_JPGOKU)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_JPGOKU then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_JPGOKU then return _G.charSelect.voice.snore(m) end
    end)
    _G.charSelect.character_add_voice(E_MODEL_KIDGOKUNOPOLEJP, VOICETABLE_JPGOKU)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_JPGOKU then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_JPGOKU then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end